using System;

using System.Collections.Generic;

using System.IO;

using UnityEngine;

using UnityEngine.Events;

namespace Mod

{

    public class Mod

    {

        public static void Main()

        {
 CategoryBuilder.Create("CBRN", "CBRN", ModAPI.LoadSprite("category.png")); 
    ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Altyn Helmet",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "A Ballistic Helmet used by the Russian FSB",
                    CategoryOverride = ModAPI.FindCategory("CBRN"),
                    ThumbnailOverride = ModAPI.LoadSprite("altyn1.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("altyn1.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 150000;
                    }
                }
            );

  
 
            
            
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "PMG1 Gasmask",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "A attempt by the russians at making a new army gasmask. ",
                    CategoryOverride = ModAPI.FindCategory("CBRN"),
                    ThumbnailOverride = ModAPI.LoadSprite("Pmg.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pmg.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 150000;
                    }
                }
            );
  ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "PMG2 Gasmask",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "A standard issue gasmask for the russian army to this day",
                    CategoryOverride = ModAPI.FindCategory("CBRN"),
                    ThumbnailOverride = ModAPI.LoadSprite("pmg2.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("pmg2.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 150000;
                    }
                }
            );
 ModAPI.Register(new Modification()
      {
        OriginalItem =  ModAPI.FindSpawnable("Crossbow"),
        NameOverride =  "CBRN Medkit",
        DescriptionOverride = "Contains a Adrenaline injection in case the heart stops beating because of nerve gases",
        CategoryOverride =  ModAPI.FindCategory("CBRN"),
        ThumbnailOverride =  ModAPI.LoadSprite("med.png", 5f, true),
        AfterSpawn =  (Instance =>
        {
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("med.png", 1f, true);
          Utils.FixColliders(Instance);
          Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset =  ModAPI.FindSpawnable("Adrenaline Syringe");
          Instance.GetComponent<ProjectileLauncherBehaviour>().projectileLaunchStrength =  0;
          Instance.GetComponent<PhysicalBehaviour>().Properties =  ModAPI.FindPhysicalProperties("Wood");
        })
      });
                       ModAPI.Register(new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "Russian CBRN Suit",
        NameToOrderByOverride = "1",
        DescriptionOverride = "A solider with a Plastic CBRN Suit.",
        CategoryOverride = ModAPI.FindCategory("CBRN"),
        ThumbnailOverride = ModAPI.LoadSprite("cbrn.png", 5f, true),
        AfterSpawn = (Action<GameObject>) (Instance =>
        {
          Texture2D texture2D19 = ModAPI.LoadTexture("cbrn.png", true);
          Texture2D texture2D20 = ModAPI.LoadTexture("5f_flesh.png", true);
          Texture2D texture2D21 = ModAPI.LoadTexture("5f_bone.png", true);
          Instance.GetComponent<PersonBehaviour>().SetBodyTextures(texture2D19, texture2D20, texture2D21, 1f);
          Instance.GetComponent<PersonBehaviour>().SetBodyTextures(texture2D19, texture2D20, texture2D21, 5f);
        })
      });      
        ModAPI.Register(new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "ISP 60 Sub-Escape Suit",
        NameToOrderByOverride = "1",
        DescriptionOverride = "A Submarine escape suit used with he IDA-59 rebreather. It was/is used by warsaw pact members.",
        CategoryOverride = ModAPI.FindCategory("CBRN"),
        ThumbnailOverride = ModAPI.LoadSprite("ISP.png", 5f, true),
        AfterSpawn = (Action<GameObject>) (Instance =>
        {
          Texture2D texture2D19 = ModAPI.LoadTexture("ISP.png", true);
          Texture2D texture2D20 = ModAPI.LoadTexture("5f_flesh.png", true);
          Texture2D texture2D21 = ModAPI.LoadTexture("5f_bone.png", true);
          Instance.GetComponent<PersonBehaviour>().SetBodyTextures(texture2D19, texture2D20, texture2D21, 1f);
          Instance.GetComponent<PersonBehaviour>().SetBodyTextures(texture2D19, texture2D20, texture2D21, 5f);
        })
      });      

  ModAPI.Register(new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "Geiger Counter",
        NameToOrderByOverride = "h",
        DescriptionOverride = "A small device that picks up radiation.",
        CategoryOverride = ModAPI.FindCategory("CBRN"),
        ThumbnailOverride = ModAPI.LoadSprite("geiger.png", 5f, true),
        AfterSpawn = (Action<GameObject>) (Instance =>
        {
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("geiger.png", 1f, true);
          Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Flammable metal");
          Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.2f;
          Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
          Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.2f;
          Utils.FixColliders(Instance);
          ArmorBehaviour armorBehaviour = Instance.AddComponent<ArmorBehaviour>();
          armorBehaviour.stabResistance = 10f;
          armorBehaviour.armorPiece = "LowerBody";
          armorBehaviour.armorTier = 1;
          AudioSource AS = Instance.AddComponent<AudioSource>();
          AS.minDistance = 1f;
          AS.maxDistance = 3f;
          int index = 0;
          AudioClip[] AudioData = new AudioClip[2]
          {
            ModAPI.LoadSound("geiger.mp3"),
            ModAPI.LoadSound("geiger.mp3")
          };
          Utils.FixColliders(Instance);
          Instance.AddComponent<UseEventTrigger>().Action = (Action) (() =>
          {
            AS.clip = AudioData[index];
            AS.Play();
            ++index;
            if (index != AudioData.Length)
              return;
            index = 0;
          });
        })
      });

  ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Altyn Helmet with CBRN cover",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "A Altyn Helmet with CBRN cover ",
                    CategoryOverride = ModAPI.FindCategory("CBRN"),
                    ThumbnailOverride = ModAPI.LoadSprite("altyn12.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("altyn12.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 150000;
                    }
                }
            );

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "GP5 Gasmask",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "The most produced Gasmask",
                    CategoryOverride = ModAPI.FindCategory("CBRN"),
                    ThumbnailOverride = ModAPI.LoadSprite("gp5.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("gp5.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 150000;
                    }
                }
            );
 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "KR-1U Rocket Refueling Hood",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "A very rare piece of euipment used by the rocket troops (Katyusha).USED IN COMBINATION WITH IP5 REBREATHER",
                    CategoryOverride = ModAPI.FindCategory("CBRN"),
                    ThumbnailOverride = ModAPI.LoadSprite("kr.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("kr.png", 1f, true);
                         Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Flammable metal");
          Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0f;
          Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0f;
          Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0f;

						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 150000;
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "IP-5 Black variant",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "A Rebreather used by tank crews and divers. Black rubber usually indicates that it was made for a officer",
                    CategoryOverride = ModAPI.FindCategory("CBRN"),
                    ThumbnailOverride = ModAPI.LoadSprite("ip4.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ip4.png", 1f, true);
                        						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 150000;
                    }
                }
            );
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "IP-5 White",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "A Rebreather used by tank crews and divers.",
                    CategoryOverride = ModAPI.FindCategory("CBRN"),
                    ThumbnailOverride = ModAPI.LoadSprite("ip6.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ip6.png", 1f, true);
                        
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 150000;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "PBF Gasmask",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "A Cheek Filter Gasmask very popular by lawenforcement.",
                    CategoryOverride = ModAPI.FindCategory("CBRN"),
                    ThumbnailOverride = ModAPI.LoadSprite("pbf.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("pbf.png", 1f, true);
                        
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 150000;
                    }
                }
            );
    ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "PBF Gasmask Black",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "A Cheek Filter Gasmask very popular by lawenforcement.",
                    CategoryOverride = ModAPI.FindCategory("CBRN"),
                    ThumbnailOverride = ModAPI.LoadSprite("pbfB.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("pbfB.png", 1f, true);
                        
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 150000;
                    }
                }
            );


 ModAPI.Register(new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "IP-5 Rebreather Unit",
        NameToOrderByOverride = "h",
        DescriptionOverride = "The Ip-5 is a so called rebreather.So you dont breathe through a filter but you rather breath through a enclosed system which scrubs the co2 and recycles the air over and over.",
        CategoryOverride = ModAPI.FindCategory("CBRN"),
        ThumbnailOverride = ModAPI.LoadSprite("chem2.png", 5f, true),
        AfterSpawn = (Action<GameObject>) (Instance =>
        {
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("chem2.png", 1f, true);
          Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Flammable metal");
          Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.2f;
          Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
          Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.2f;
          Utils.FixColliders(Instance);
          ArmorBehaviour armorBehaviour = Instance.AddComponent<ArmorBehaviour>();
          armorBehaviour.stabResistance = 10f;
          armorBehaviour.armorPiece = "UpperBody";
          armorBehaviour.armorTier = 1;
          AudioSource AS = Instance.AddComponent<AudioSource>();
          AS.minDistance = 1f;
          AS.maxDistance = 3f;
          int index = 0;
          AudioClip[] AudioData = new AudioClip[2]
          {
            ModAPI.LoadSound("breathe.wav"),
            ModAPI.LoadSound("breathe.wav")
          };
          Utils.FixColliders(Instance);
          Instance.AddComponent<UseEventTrigger>().Action = (Action) (() =>
          {
            AS.clip = AudioData[index];
            AS.Play();
            ++index;
            if (index != AudioData.Length)
              return;
            index = 0;
          });
        })
      });
 ModAPI.Register(new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "Russian Field Radio",
        NameToOrderByOverride = "h",
        DescriptionOverride = "A field Radio used to recieve orders from the higher ups.",
        CategoryOverride = ModAPI.FindCategory("CBRN"),
        ThumbnailOverride = ModAPI.LoadSprite("headp.png", 5f, true),
        AfterSpawn = (Action<GameObject>) (Instance =>
        {
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("headp.png", 1f, true);
                 Utils.FixColliders(Instance);
          ArmorBehaviour armorBehaviour = Instance.AddComponent<ArmorBehaviour>();
          armorBehaviour.stabResistance = 10f;
          armorBehaviour.armorPiece = "MiddleBody";
          armorBehaviour.armorTier = 1;
          AudioSource AS = Instance.AddComponent<AudioSource>();
          AS.minDistance = 1f;
          AS.maxDistance = 3f;
          int index = 0;
          AudioClip[] AudioData = new AudioClip[2]
          {
            ModAPI.LoadSound("radio.wav"),
            ModAPI.LoadSound("radio.wav")
          };
          Utils.FixColliders(Instance);
          Instance.AddComponent<UseEventTrigger>().Action = (Action) (() =>
          {
            AS.clip = AudioData[index];
            AS.Play();
            ++index;
            if (index != AudioData.Length)
              return;
            index = 0;
          });
        })
      });

 ModAPI.Register(new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "ISP-60 Hood",
        NameToOrderByOverride = "h",
        DescriptionOverride = "The ISP-60 With Adapter for the rebreather unit.",
        CategoryOverride = ModAPI.FindCategory("CBRN"),
        ThumbnailOverride = ModAPI.LoadSprite("ISP60.png", 5f, true),
        AfterSpawn = (Action<GameObject>) (Instance =>
        {
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ISP60.png", 1f, true);
                   Utils.FixColliders(Instance);
          ArmorBehaviour armorBehaviour = Instance.AddComponent<ArmorBehaviour>();
          armorBehaviour.stabResistance = 10f;
          armorBehaviour.armorPiece = "Head";
          armorBehaviour.armorTier = 1;
          AudioSource AS = Instance.AddComponent<AudioSource>();
          AS.minDistance = 1f;
          AS.maxDistance = 3f;
          int index = 0;
          AudioClip[] AudioData = new AudioClip[2]
          {
            ModAPI.LoadSound("breathe.wav"),
            ModAPI.LoadSound("breathe.wav")
          };
          Utils.FixColliders(Instance);
          Instance.AddComponent<UseEventTrigger>().Action = (Action) (() =>
          {
            AS.clip = AudioData[index];
            AS.Play();
            ++index;
            if (index != AudioData.Length)
              return;
            index = 0;
          });
        })
      });

ModAPI.Register(new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "IDA-59 Rebreather Unit",
        NameToOrderByOverride = "h",
        DescriptionOverride = "The IDA-59 is a so called rebreather.So you dont breathe through a filter but you rather breath through a enclosed system which scrubs the co2 and recycles the air over and over.",
        CategoryOverride = ModAPI.FindCategory("CBRN"),
        ThumbnailOverride = ModAPI.LoadSprite("ida.png", 5f, true),
        AfterSpawn = (Action<GameObject>) (Instance =>
        {
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ida.png", 1f, true);
                   Utils.FixColliders(Instance);
          ArmorBehaviour armorBehaviour = Instance.AddComponent<ArmorBehaviour>();
          armorBehaviour.stabResistance = 10f;
          armorBehaviour.armorPiece = "UpperBody";
          armorBehaviour.armorTier = 1;
          AudioSource AS = Instance.AddComponent<AudioSource>();
          AS.minDistance = 1f;
          AS.maxDistance = 3f;
          int index = 0;
          AudioClip[] AudioData = new AudioClip[2]
          {
            ModAPI.LoadSound("hiss.mp3"),
            ModAPI.LoadSound("hiss.mp3")
          };
          Utils.FixColliders(Instance);
          Instance.AddComponent<UseEventTrigger>().Action = (Action) (() =>
          {
            AS.clip = AudioData[index];
            AS.Play();
            ++index;
            if (index != AudioData.Length)
              return;
            index = 0;
          });
        })
      });

 

        }

    }

}
